/**
 * Created by JetBrains PhpStorm
 * User: liming
 * 插入块的删除
 * Date: 16/7/15
 */

(function () {
    tinymce.PluginManager.add('dminsertcontent', function(tinyMCEEditor) {
        tinyMCEEditor.on('init', function(e) {
            tinyMCEEditor.formatter.register('atuser', {
                inline: 'span',
                attributes: {
                    classe: 'at-user',
                    'data-id': '%userId',
                },
            });
        });

        function conversionGifToNormalImage () {
            const $dom = $(tinyMCEEditor.getBody());
            $dom.remove('.mce-offscreen-selection').find('.dm_insert_img img').each(function () {
                const $target = $(this);
                const $gifIcon = $target.siblings('.gif-icon');
                let imageUrl = $target.attr('src');
                if (imageUrl.match('.gif')) {
                    let gifUrl = imageUrl;
                    imageUrl = getGifFirstFrameUrl(gifUrl);
                    if ($gifIcon.length) {
                        $gifIcon.addClass('gif-show');
                    } else {
                        let $gitIconContent = $('<span class="gif-icon gif-show" style="display: none;">GIF</span>');
                        $target.after($gitIconContent);
                    }
                    const width = $target.data('w');
                    const height = $target.data('h');
                    const $newImg = '<img src="' +  imageUrl + '" data-w='+width+' data-h="'+height+'" data-gif="'+ gifUrl + '" />';
                    $target.replaceWith($newImg);
                } else {
                    if ($gifIcon.length) {
                        $gifIcon.removeClass('gif-show');
                    }
                }
                
            });
        }

        function getGifFirstFrameUrl (url = '', size = '800_0', type = '60') {
            if (!url) return '';
            // 如果不是本站的图片，返回原图
            if (!/^[^\.]+\.dealmoon\./.test(url)) {
              return url;
            }
            let protocal = 'https:';
            let orginUrl = '';
            // 如果图片是//开头，加上protocal，防止生成连接后出错
            if (/^\/\//.test(url)) {
              url = `${protocal}//${url}`;
            }
            // 如果判断图片已经做了转换，提取出原图再转换
            let regexp = /^((https?\:)\/\/\w+cache\.dealmoon.com\/)(.+)(_\d+_\d+_\d+_[0-9a-z]{4}\.[\w]{2,4})$/;
            let matches = url.match(regexp);
            if (matches === null) {
              orginUrl = url.replace(/^https?:\/\//, '');
            } else {
              [, , protocal, orginUrl] = matches;
            }
            let commboUrl = `${orginUrl}_${size}_${type}`;
            // keep secret!
            let key = md5(`&6#dealmoon.magic.GG${commboUrl}`).substr(0, 4);
            let suffix = url.split('.').pop();
            // 获取图片服务器
            let cacheServer = `imgcache.dealmoon.com`;
            return `${protocal}//${cacheServer}/${commboUrl}_${key}.${suffix || 'jpg'}`;
        };

        const envHostNameMap = {
            'it1': 'it1',
            'it2': 'it2',
            'it3': 'it3',
            'it4': 'it4',
            'it5': 'it5',
            'it6': 'it6',
            'it7': 'it7',
            'it8': 'it8',
            'it100': 'it100',
            'at1': 'at1',
            'at2': 'at2',
            'st1.dealmoon': 'st1',
            'st1au': 'st1au',
            'st1uk': 'st1uk',
            'st1ca': 'st1ca',
            'st1de': 'st1de',
            'st1fr': 'st1fr',
        };

        const prodHostNameMap = {
            'dealmoon.fr': 'dealmoon.fr',
            'dealmoon.ca': 'dealmoon.ca',
            'dazhe.de': 'dazhe.de',
            'com.au': 'dealmoon.com.au',
            'co.uk': 'dealmoon.co.uk',
        };

        function getHostName(url) {
            let hostName = 'https://cn.dealmoon.com';
            let isMatch = false;
            for (prodName in prodHostNameMap) {
                isMatch = !!url.match(prodName);
                if (isMatch) {
                    hostName = `${prodHostNameMap[prodName]}`;
                    break;
                }
            }
            if (!isMatch) {
                for (envName in envHostNameMap) {
                    isMatch = !!url.match(envName);
                    if (isMatch) {
                        hostName = `${envHostNameMap[envName]}.dealmoon.net`;
                        break;
                    }
                }
            }
            if (isMatch) {
                hostName = `https://cn.${hostName}`;
            }
            return hostName;
        }

        // 空行调整间距
        function emptyPTagMargin () {
            const $curNode = $(tinyMCEEditor.selection.getNode());
            const $curNodeParent = $curNode.parents('p');
            const $node = $curNodeParent.length ? $curNodeParent : $curNode;
            const $isP = $node[0].tagName === 'P';
            const text = $node.text().replace(/\s/g, '');
            // const hasEmptyClass = $node.hasClass('app-empty-p');
            const nodeChildrenLength = $node.children().length;
            const onlyHasBr = (nodeChildrenLength === 1 && $node.children('br').length === 1) || nodeChildrenLength === 0;
            // if ((text || !onlyHasBr) && hasEmptyClass) {
            //     $node.removeClass('app-empty-p');
            // } else if ($isP && (!text && onlyHasBr) && !hasEmptyClass) {
            //     $node.addClass('app-empty-p');
            // }
        }

        // 顶部是内容元素时需要增加一行
        function prevEleIsContentBlock () {
            const eleIsContentBlock = $(tinyMCEEditor.selection.getNode()).prev().hasClass('dm_insert_block');
            return eleIsContentBlock;
        }

        // 插入内容元素后，删除多余的br
        function afterInsetDeleteBr () {
            const $node = $(tinyMCEEditor.selection.getNode())
            const $br = $node.children('br');
            const text = $node.text();
            if ($br.length === 2 && !text) {
                $br.first().remove();
            }
        }

        function guid() {
             function S4() {
                 return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
             }
             return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
        }

        function makeImageContent (data) {
            const images = JSON.parse(decodeURIComponent(data));
            // 顶部是内容元素时需要增加一行
            const eleIsContentBlock = prevEleIsContentBlock();
            // const brEle = eleIsContentBlock ? '<p class="app-empty-p"></p>' : '';
            let imageContent = images.map(img => {
                const uniqueId = guid();
                let imgUrl = img.url;
                let gitUrl = '';
                let gitIcon = '';
                const isGif = imgUrl.match('.gif');
                if (isGif) {
                    gitUrl = imgUrl;
                    imgUrl = getGifFirstFrameUrl(imgUrl);
                    gitIcon = '<span class="gif-icon gif-show" style="display: none;">GIF</span>'
                }

                return '<div id="' + uniqueId + '" class="dm_insert_img dm_insert_block mceNonEditable" contenteditable="false">\
                            <div class="pos_positive">\
                                <div style="position: relative;">\
                                    <img src="' + imgUrl + '" data-w='+img.width+' data-h="'+img.height+'" data-gif="'+ gitUrl +'"/>\
                                    <div class="dm_edit_action mceNonEditable" style="display: none;" contenteditable="false" data-mce-style="display: none;">\
                                        <button class="btn del_btn mceNonEditable" contenteditable="false">删除</button>\
                                        <button class="btn link_btn mceNonEditable" contenteditable="false">Link</button>\
                                        <button class="btn comment_btn mceNonEditable" style="display: block;" contenteditable="false" data-mce-style="display: block;">注释</button>\
                                        <button class="btn imgsize_btn mceNonEditable" contenteditable="false">小图</button>\
                                    </div>\
                                    '+ gitIcon+'\
                                </div>\
                                <div class="dm_comment" style="display: none;" contenteditable="false"></div>\
                            </div>\
                        </div><p></p>';
                        // </div></p>';
            });
            return imageContent.join('');
            // return brEle + imageContent.join('');
        }

        function makePostContent (postData) {
            // const uniqueId = 'usg_' + new Date().getTime();
            const uniqueId = 'usg_' + guid();
            const id = postData.id;
            const url = postData.url;
            const description = postData.description || postData.newDescription;
            const imgs = postData.imgs;
            const author = postData.author;
            const avatar = author.avatar;
            const userName = author.name;
            const level = author.level;

            let imgContent = '';
            imgs.forEach(function (item) {
                const imgUrl = item.url;
                const imgWidth = item.url;
                const imgHeight = item.height;
                const ratio = (imgHeight / imgHeight).toFixed(2);
                const img = '<img class="pro_img" src="' + imgUrl + '" data-w="' + imgWidth + '" data-h="' + imgHeight + '" data-ratio="' + ratio + '" data-mce-src="' + imgUrl + '">';
                imgContent = imgContent + img;
            });
            const postContent = '<div class="dm_insert_block user_share_goods mceNonEditable" contenteditable="false" data-type="user-share-goods" data-id="' + id + '" data-dom-id="' + uniqueId + '">\
                                    <a href="' + url + '" target="_blank" rel="noopener">\
                                        <div class="pro_img_block">\
                                            ' + imgContent + '\
                                            <div class="dm_edit_action" style="display: none;" data-mce-style="display: none;">\
                                                <button class="btn del_btn" contenteditable="false">删除</button>\
                                                <button class="btn edit_btn" contenteditable="false">编辑</button>\
                                            </div>\
                                        </div>\
                                        <div class="pro_content">\
                                            <p class="title text_overflow" contenteditable="false">\
                                                <img src="' + avatar + '" data-mce-src="' + avatar + '">\
                                                <span class="user-name">' + userName + '</span>&nbsp;\
                                                <img class="level-img" src="https://www.dealmoon.com/assets/images/guide/lv.png" data-mce-src="https://www.dealmoon.com/assets/images/guide/lv.png">\
                                                <span class="level-num">' + level + '</span>\
                                            </p>\
                                            <div class="content mceNonEditable" contenteditable="false">' + description + '</div>\
                                        </div>\
                                    </a>\
                                </div><p></p>';
            return postContent;
        }

        function makeSpContent (spData) {
            let url = '', spContent = '', uniqueId, spId, discountId, referUrl, iframeId, isDmSp, dataType;
            // uniqueId = 'usg_eg_' + new Date().getTime();
            uniqueId = 'usg_eg_' + guid();
            spId = spData.spId;
            isDmSp = spData.isDmSp;
            discountId = spData.id;
            referUrl = spData.referUrl || spData.host || '';
            iframeId = 'dm_single_product_' + spId + '_' + discountId;
            dataType = isDmSp ? 'single-product' : 'external_product';
            url = getHostName(referUrl);
            // 顶部是内容元素时需要增加一行
            const eleIsContentBlock = prevEleIsContentBlock();
            // const brEle = eleIsContentBlock ? '<p class="app-empty-p"></p>' : '';
            url = url + '/guide/sp/' + spId + '?fromAppEditor=1&spDiscountId=' + discountId;

            spContent = '<div class="dm_insert_block dm_single_product mceNonEditable" data-dom-id="' + uniqueId + '" data-sp-id="' + spId + '" data-sp-discount-id="' + discountId + '" data-type="' + dataType + '" contenteditable="false">\
                            <iframe id="' + iframeId + '" src="' + url + '" width="600" height="110" frameborder="none" scrolling="no" data-discount-id="' + discountId + '" data-mce-src="' + url + '"></iframe>\
                            <p class="sp-mask dm-editor-mask" style="display: none"></p>\
                            <div class="dm_edit_action" style="display: none;" data-mce-style="display: none;">\
                                <button class="btn del_btn" contenteditable="false">删除</button>\
                                <button class="btn edit_btn" contenteditable="false">编辑</button>\
                            </div>\
                        </div><p></p>';
                        // </div></p>';
            return spContent;
            // return brEle + spContent;
        }

        function makeLinkContent (linkAttrs) {
            const linkContent = '<a contenteditable="false" id="' + linkAttrs.id + '" class="' + linkAttrs.class + '" title="' + linkAttrs.title + '" href="' + linkAttrs.href + '" target="_blank" rel="' + linkAttrs.rel + '" data-id="' + linkAttrs['data-id'] + '" data-mce-href="' + linkAttrs.href + '">' + linkAttrs.title + '</a>  '
            return linkContent;
        }

        // 插入内容
        function editorInsertContent (content) {
            // tinyMCEEditor.insertContent(content);
            // tinyMCEEditor.focus();
            tinyMCEEditor.execCommand('mceInsertContent', false, `${content}`);
            // tinyMCEEditor.focus();
            tinyMCEEditor.undoManager.add();
            window.dmEditor.editorChangeContent();

            // const $dom = $(tinyMCEEditor.getBody());

            // function resetPointer () {
            //     $dom.find(".dm_insert_img, .dm_single_product, .dm_link, .user_share_goods, .dm-tag").each(function () {
            //         $target = $(this);
            //         $target.css('pointerEvents', '');
            //     });
            // }

            // $dom.find(".dm_insert_img, .dm_single_product, .dm_link, .user_share_goods, .dm-tag").each(function () {
            //     $target = $(this);
            //     $target.css('pointerEvents', 'none');
            // });
            // const resetProperty = setTimeout(function () {
            //     resetPointer();
            //     clearTimeout(resetProperty);
            // }, 4000);
        }


        // 插入图片
        function editorInsertImage (data) {
            const imageContent = makeImageContent(data);
            window.dmEditor.cancleListBlockquote();
            editorInsertContent(imageContent);
            window.dmEditor.requestFocus && window.dmEditor.requestFocus();
            afterInsetDeleteBr();
        }

        // 插入链接
        function editorInsertLink(data) {
            data = decodeURIComponent(data);
            // data = '{"href":"www.baidu.com","title":"hhjjju","range":{"bookmark":{"id":"mce_2"},"endOffset":0,"selectionText":"","startOffset":0}}'
            data = JSON.parse(data);
            const href = data.href;
            const title = data.title;
            const range = data.range;
            const dataId = new Date().getTime();
            const uniqueId = 'a_' + String(dataId);
            const linkAttrs = {
                href: href,
                id: uniqueId,
                target: '_blank',
                rel: 'nofollow noopener',
                class: 'dm_link dm_tracking mceNonEditable',
                title: title || href,
                'data-id': dataId,
                contenteditable: 'false'
            };
            const selection = tinyMCEEditor.selection;
            if (range && range.bookmark) {
                selection.moveToBookmark(range.bookmark);
            }
            const linkContent = makeLinkContent(linkAttrs);
            editorInsertContent(linkContent);
            emptyPTagMargin();
        }

        // 插入单品
        function editorInsertSp(data) {
            // data = '%7B%0A%20%20%22imgUrl%22%20:%20%22https:%5C/%5C/imgcache.dealmoon.com%5C/thumbimg.dealmoon.com%5C/dealmoon%5C/d96%5C/493%5C/18c%5C/b3b71b59627419ba53c5680.jpg_200_200_2_67a5.jpg%22,%0A%20%20%22url%22%20:%20%22https:%5C/%5C/www.adidas.com%5C/us%22,%0A%20%20%22isDmSp%22%20:%20true,%0A%20%20%22id%22%20:%20%225539124%22,%0A%20%20%22price%22%20:%20%22220.00%22,%0A%20%20%22title%22%20:%20%22adidas%E5%AE%98%E7%BD%91%20Yeezy%20Boost%20350%20V2%20%5C%22Zyon%5C%22%E9%85%8D%E8%89%B2%20%E6%8A%BD%E7%AD%BE%E5%B7%B2%E5%BC%80%E5%90%AF%22,%0A%20%20%22spId%22%20:%20%223852978%22,%0A%20%20%22store%22%20:%20%22adidas%22%0A%7D';
            const contentString = decodeURIComponent(data);
            const spdata = JSON.parse(contentString);
            const spContent = makeSpContent(spdata);
            window.dmEditor.cancleListBlockquote();
            editorInsertContent(spContent);
            afterInsetDeleteBr();
            // const spContent = makeSpContent();
            // editorInsertContent(spContent);
        }

        // 插入@好友
        function editorInsertFriend (data) {
            data = decodeURIComponent(data);
            data = JSON.parse(data);
            const friendId = data.linkId;
            const containsAt = data.containsAt;
            const friendName = data.name;
            const hostName = data.hostName;
            // 用户输入艾特符号
            if (containsAt === 'true' || containsAt === true) {
                // const selection = tinyMCEEditor.selection;
                // const rng = selection.getRng();
                // const $node = selection.getNode();
                // if (rng.endOffset) {
                //     rng.setStart($node, rng.endOffset - 1);
                //     rng.setEnd($node, rng.endOffset);
                //     rng.deleteContents();
                // }
                const selection = tinyMCEEditor.dom.select("span#delimiter")[0];
                tinyMCEEditor.dom.remove(selection);
            }
            // 用户点击艾特按钮
            let link = getHostName(hostName);
            link = `${link}/u/${friendId}`;
            // const link = 'https://www.dealmoon.com/u/' + friendId;
            const atUserContent = '<a href="' + link + '" class="dm-tag dm-tag-user mceNonEditable" data-id="' + friendId + '" data-name="' + friendName + '" data-type="user" data-link="https://www.dealmoon.com/u/' + friendId + '">@' + friendName + '</a>  ';
            editorInsertContent(atUserContent);
            emptyPTagMargin();
            return;
        }

        // 插入晒货
        function editorInsertBlock(data) {
            const contentString = decodeURIComponent(data);
            const contentList = JSON.parse(contentString);
            // 顶部是内容元素时需要增加一行
            const eleIsContentBlock = prevEleIsContentBlock();
            // const brEle = eleIsContentBlock ? '<p class="app-empty-p"></p>' : '';
            if (Array.isArray(contentList) && contentList.length) {
                let content = '';
                contentList.forEach(function(item) {
                    switch (item.contentType) {
                        case 'post':
                                content = content + makePostContent(item);
                            break;
                        default:
                            break;
                    }
                });
                content = content;
                // content = brEle + content;
                window.dmEditor.cancleListBlockquote();
                editorInsertContent(content);
                afterInsetDeleteBr();
            }
        }

        // 插入tag
        function editorInsertTag(data) {
            data = decodeURIComponent(data);
            const _data = JSON.parse(data);
            const {type,name,linkId,link = '', sourceData = {}, subType = ''} = _data || {};
            const defaultClassName = 'dm-brand-tag';
            let className = {
                brand:'dm-tag-brand',
                location:'dm-tag-location',
                hashtag:'dm-tag-hashtag',
            };
            if (!className[type]) {
                className = defaultClassName;
            }
            const tagHtml = '<a data-subtype="' + subType + '" data-source="' + encodeURIComponent(JSON.stringify(sourceData)) + '" href="' + link + '" class="mceNonEditable dm-tag ' + className[type] + '" data-id="' + linkId + '" data-name="' + name + '" data-type="' + type + '" data-link="' + link + '">' + name + '</a>  ';
            editorInsertContent(tagHtml);
            emptyPTagMargin();
            return;
        }
        // 安卓初始化文章入口
        function editorInitArticleAndroid (data) {
            data = data.replace(/\n/g, '%0A');
            data = data.replace(/\r/g, '%0D');
            let articleDetail = JSON.parse(data);
            articleDetail.content = articleDetail.content.replace(/\%22/g, '\"');
            articleDetail.content = articleDetail.content.replace(/\%27/g, "\'");
            articleDetail.content = articleDetail.content.replace(/\%0A/g, '\n');
            articleDetail.content = articleDetail.content.replace(/\%0D/g, '\r');
            editorInitArticle(articleDetail);

        }
        // ios初始化文章入口
        function editorInitArticleIOS (data) {
            editorInitArticle(data);
        }

        // 初始化文章
        function editorInitArticle (data) {

            // 初始化
            $('#title').val('');
            $('#title').attr('rows', 1);
            $('#title-tip-num').text(40);
            $('#title-height').text('');
            tinyMCEEditor.resetContent();

            let articleDetail = data;
            let title = articleDetail.title;
            const content = articleDetail.content;

            tinyMCEEditor.setContent(content);
            if (title) {
                let rows, remainNum;
                title = title.substring(0, 40);
                $('#title-height').text(title);
                rows = $('#title-height').height() / 32;
                remainNum = 40 - title.length;
                $('#title').attr('rows', rows);
                $('#title').val(title);
                $('#title-tip-num').text(remainNum);
            }
            

            const $dom = $(tinyMCEEditor.getBody());
            $dom.find('.dm_link').attr('contenteditable', false);
            $dom.find('.dm_link').addClass('mceNonEditable');
            $dom.find('.dm_single_product iframe').each(function () {
                const $target = $(this);
                let src = $target.attr('src');
                if (!src.match('fromAppEditor=1')) {
                    src = src + '&fromAppEditor=1';
                    $target.attr('src', src);
                }
                if (!$target.next().hasClass('sp-mask')) {
                    $target.after($('<p class="sp-mask" style="display: none"></p>'));
                }
                
            });
            $dom.find('.dm_insert_img .dm_comment').each(function () {
                const $target = $(this);
                const comment = $target.text();
                const cssDisplay = comment ? 'block' : 'none';
                $target.attr('contenteditable', false);
                $target.css('display', cssDisplay).attr('data-mce-style', 'display: ' + cssDisplay);
            });

            conversionGifToNormalImage();

            tinyMCEEditor.undoManager.clear();

            window.dmEditor.articleDetail.links = articleDetail.links;
            // 记录数据，提交时判断是否编辑
            window.dmEditor.articleDetail.title = title;
            window.dmEditor.articleDetail.content = content;
            // 
            window.dmEditor.hasContent.editor = content.length > 0;
            window.dmEditor.hasContent.title = title.length > 0;
            if (window.dmEditor.hasContent.editor && window.dmEditor.hasContent.title && window.dmEditor.messageAppHasContent) {
                let parmas = {
                    hasContent: true
                };
                parmas = JSON.stringify(parmas);
                window.dmEditor.messageAppHasContent(parmas);
            }

        }

        // 给APP使用的api
        window.dmEditor.editorInitArticleIOS = editorInitArticleIOS;
        window.dmEditor.editorInitArticleAndroid = editorInitArticleAndroid;
        window.dmEditor.editorInitArticle = editorInitArticle;
        window.dmEditor.editorInsertSp = editorInsertSp;
        window.dmEditor.editorInsertFriend = editorInsertFriend;
        window.dmEditor.editorInsertLink = editorInsertLink;
        window.dmEditor.editorInsertBlock = editorInsertBlock;
        window.dmEditor.editorInsertImage = editorInsertImage;
        window.dmEditor.editorInsertContent = editorInsertContent;
        window.dmEditor.editorInsertTag = editorInsertTag;
        window.dmEditor.emptyPTagMargin = emptyPTagMargin;
        window.dmEditor.getGifFirstFrameUrl = getGifFirstFrameUrl;
        window.dmEditor.conversionGifToNormalImage = conversionGifToNormalImage;
    });
})();